#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "grb2.h"
#include "wgrib2.h"
#include "fnlist.h"

/*
 * Prob.c
 *
 *  Some routines for probablilty forecasts
 *
 * 11/2008: Public Domain: Wesley Ebisuzaki
  *
 */

#define LOWER_LIMIT scaled2flt(INT1(p[1]), int4(p+2))
#define UPPER_LIMIT scaled2flt(INT1(p[6]), int4(p+7))

/*
 * HEADER:100:prob:inv:0:probability information
 */
int f_prob(ARG0) {
    unsigned char *p;
    int code_table4_9;
    float low, hi;

    if (mode == -1) {
	return 0;
    }
    else if (mode >= 0) {
	p = code_table_4_9_location(sec);
	if (p == NULL) return;
        code_table4_9 = *p;
	sprintf(inv_out,"probtype=%d ",*p);
	switch (*p) {
	case 0: sprintf(inv_out,"prob<%g", LOWER_LIMIT);
		break;
	case 1: sprintf(inv_out,"prob>%g", UPPER_LIMIT);
		break;
	case 2: sprintf(inv_out,"prob>%g <%g", LOWER_LIMIT,UPPER_LIMIT);
		break;
	case 3: sprintf(inv_out,"prob>%g", LOWER_LIMIT);
		break;
	case 4: sprintf(inv_out,"prob<%g", UPPER_LIMIT);
		break;
	}
    }
    return 0;
}

